> ## Documentation Index
> Fetch the complete documentation index at: https://docs.nmbr.co/llms.txt
> Use this file to discover all available pages before exploring further.

# Generate forms

> Endpoint to generate forms with the values suggested by Nmbr.

This is only possible for forms that support generation (T4/T4A/RL-1).

This example uses a T4 form, but the same applies to other forms.



## OpenAPI

````yaml /spec/openapi.json post /form_types/{form_type}/generate
openapi: 3.0.0
info:
  title: Nmbr API
  description: API to interact with Nmbr Payroll
  version: 1.0.0
servers:
  - url: https://sandbox.nmbr.co/services/payroll
security:
  - CompanyToken: []
tags:
  - name: Accounting Codes
  - name: Accounting Code Rules
  - name: Adjustments
  - name: Allowances
  - name: Allowance Line Items
  - name: Allowance Types
  - name: Async Tasks
  - name: Bank Accounts
  - name: Business Entities
  - name: Business Entity Verifications
  - name: Business Entity ROE Authorizations
  - name: Business Presets
  - name: Calculations
  - name: Companies
  - name: Contractors
  - name: Deductions
  - name: Deduction Line Items
  - name: Deduction Types
  - name: Earnings
  - name: Earning Line Items
  - name: Earning Types
  - name: Effective Tax Properties
  - name: Employees
  - name: Employee Benefits
  - name: Employee Benefit Line Items
  - name: Employee Benefit Types
  - name: Employer Benefits
  - name: Employer Benefit Line Items
  - name: Employer Benefit Types
  - name: Employer Statutory Withholding Line Items
  - name: Employer Statutory Withholding Types
  - name: Forms
  - name: Form Batches
  - name: Form Types
  - name: Holidays
  - name: Integrations
  - name: Journal Entries
  - name: Overtime Rates
  - name: Partners
  - name: Pay Rates
  - name: Pay Schedules
  - name: Pay Splits
  - name: Pay Stubs
  - name: Payments
  - name: Payrolls
  - name: Reimbursements
  - name: Reimbursement Line Items
  - name: Reimbursement Types
  - name: Remittance Accounts
  - name: Remittance Account Enrollments
  - name: Reports
  - name: Statutory Withholding Line Items
  - name: Statutory Withholding Types
  - name: Tags
  - name: Tag Groups
  - name: Tax Properties
  - name: Tax Property Templates
  - name: Tokens
  - name: Usage Records
  - name: Usage Summaries
  - name: Vacation Pay
  - name: Vacation Pay Settings
  - name: Webhooks
  - name: Work Assignments
paths:
  /form_types/{form_type}/generate:
    post:
      tags:
        - Form Types
      summary: Generate forms
      description: |-
        Endpoint to generate forms with the values suggested by Nmbr.

        This is only possible for forms that support generation (T4/T4A/RL-1).

        This example uses a T4 form, but the same applies to other forms.
      operationId: form-types-generate
      parameters:
        - name: form_type
          in: path
          schema:
            type: string
          required: true
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                form_batch_id:
                  type: string
                  description: The form batch to add the generated forms to.
                effective_date:
                  type: string
                  description: >-
                    Determines which form variant to generate. Must be a date
                    for which a generator is configured for the given form type.
                  format: date
            example:
              effective_date: '2026-01-01'
      responses:
        '201':
          description: Created
          content:
            application/json:
              schema:
                type: object
                properties:
                  id:
                    type: string
                    description: The unique identifier of the object in Nmbr.
                    readOnly: true
                  object:
                    type: string
                    description: The type of the object in Nmbr (`"async_task"`).
                    readOnly: true
                  data:
                    $ref: '#/components/schemas/FormType'
              example:
                id: <id>
                object: async_task
                data:
                  type: form_generation
                  status: processing
                  completed_at: null
                  results: []
                  created_at: '2026-01-01T00:00:00.000000Z'
                  updated_at: '2026-01-01T00:00:00.000000Z'
                links:
                  self: /async_tasks/<id>
components:
  schemas:
    FormType:
      type: object
      title: Form Type
      properties:
        type:
          type: string
          description: The string identifier for this form type.
          nullable: true
          enum:
            - rl1
            - roe
            - t4
            - t4a
            - td1
            - td1ab
            - td1bc
            - td1mb
            - td1nb
            - td1nl
            - td1ns
            - td1nt
            - td1nu
            - td1on
            - td1pe
            - td1sk
            - td1x
            - td1yt
            - tp_1015_3_v
            - tp_1015_r_13_v
        label:
          type: string
          description: The human-readable display name for this form type.
          nullable: true
        version_year:
          type: number
          nullable: true
          format: decimal
        version_month:
          type: string
          nullable: true
        owner_types:
          type: array
          description: The owner types that can have forms of this type.
          nullable: true
          items:
            type: string
        exportable_as:
          type: object
          nullable: true
        supports_population:
          type: boolean
        supports_generation:
          type: boolean
        fields:
          type: array
          nullable: true
          items:
            type: object
            properties:
              key:
                type: string
                nullable: true
              label:
                type: string
                nullable: true
              type:
                type: string
                nullable: true
                enum:
                  - rl1
                  - roe
                  - t4
                  - t4a
                  - td1
                  - td1ab
                  - td1bc
                  - td1mb
                  - td1nb
                  - td1nl
                  - td1ns
                  - td1nt
                  - td1nu
                  - td1on
                  - td1pe
                  - td1sk
                  - td1x
                  - td1yt
                  - tp_1015_3_v
                  - tp_1015_r_13_v
              required:
                type: boolean
              readonly:
                type: boolean
  securitySchemes:
    CompanyToken:
      type: http
      scheme: bearer

````